using Amazon.Lambda.Core;
using Amazon.Lambda.SQSEvents;
using System.Text.Json;

[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]

namespace AdultOrChild;

public class Function
{
    DateTime _today;
    public Function()
    {
         _today = DateTime.Today;
    }
    public Person FunctionHandler(Person person, ILambdaContext context)
    {
        context.Logger.LogLine($"Person: {JsonSerializer.Serialize(person)}");
        var age = _today.Year - person.DateOfBirth.Year;
        if (person.DateOfBirth.Date > _today.AddYears(-age)) age--;
        person.Age = age;
        person.IsAdult = age >= 18;
        return person;
    }
}

public class Person
{
    public string FirstName { get; set; }
    public string LastName { get; set; }
    public DateTime DateOfBirth { get; set; }
    public int Age { get; set; }
    public bool IsAdult { get; set; }
}